# -*- coding: utf-8 -*-
from setuphelpers import *
from waptpackage import control_to_dict
import codecs

uninstallkey = []

def install():

    run_notfatal('apt-get remove rednotebook -y')
    print('installing Rednotebook')
    version_red = control.version.split('-')[0]
    run('tar -xf v%s.tar.gz' % version_red)
    if isdir('/opt/rednotebook'):
        remove_tree('/opt/rednotebook')
    copytree2('rednotebook-%s' % version_red , '/opt/rednotebook')
    run('chown -R root:root /opt/rednotebook')


    run('apt-get install python3 -y')
    with codecs.open(r'/opt/rednotebook/debian/control', encoding='utf8') as f:
        dict_control = control_to_dict(f.read().replace('\n\n','\n'))
    for p in dict_control['depends'].replace('\n','').split(','):
        if not p.startswith('$'):
            run('apt-get install %s -y' % p)

    run('apt-get install python3-enchant -y')

    filecopyto('rednotebook.desktop','/usr/share/applications/rednotebook.desktop')
    run('chown root:root /usr/share/applications/rednotebook.desktop')

def uninstall():
    remove_tree('/opt/rednotebook')
    remove_file('/usr/share/applications/rednotebook.desktop')

def update_package():
    import re
    import json

    proxies = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':proxywapt,'https':proxywapt}

    v = [(str(p['browser_download_url'])) for p in json.loads(wgets('https://api.github.com/repos/jendrikseipp/rednotebook/releases/latest',proxies=proxies))['assets'] if '.exe' in p['name']][0].split('/')[-2]
    urlfile = 'https://github.com/jendrikseipp/rednotebook/archive/%s.tar.gz' % v
    filename = '%s.tar.gz' % v

    exes = glob.glob('*.tar.gz')
    for fn in exes:
        if fn != filename:
            remove_file(fn)

    if not isfile(filename):
        print('Downloading %s from %s'%(filename,urlfile))
        wget(urlfile,filename,proxies=proxies)
    else:
        print('Already up to date, skipped')

    control.version = v.strip('v') + '-0'
    control.save_control_to_wapt()
